# -----------------------------------------------------------------------------
sub sqlJobs
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;

  $debug_jobs  = 0;
  $debug_jobs2 = 0;

  $count_this_failure  = 0;

  my %job_tr_row; 
  my $this_line;
  my $job_good_owner = "SA"; 
  my $job_owner_fix; 
  my $job_owner_rollback; 
  my $job_owner_counter = 0; 
  my $job_failed_counter = 0; 
  my $job_failed_details = ""; 

  my $this_excl_string = ""; 

  #if ($t_arclog_w[$thishost] eq "N")
  #{
  #  &logit("(Not Selected (T_Arclog_Full: is N)",$thishost);
  #  return 1;
  #}
  ##---- 2011/01/02 BB - Was 95/99
  #if ($t_arclog_w[$thishost] eq "") { $t_arclog_w[$thishost] = "80" }
  #if ($t_arclog_c[$thishost] eq "") { $t_arclog_c[$thishost] = "90" }

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  #DEBUG_PA: pa_words[2]=(category='Data Collector')
  #DEBUG_PA: pa_words[3]=(current_execution_status='4')
  #DEBUG_PA: pa_words[4]=(current_execution_step='0 (unknown)')
  #DEBUG_PA: pa_words[5]=(current_retry_attempt='0')
  #DEBUG_PA: pa_words[6]=(date_created='2010-12-01 16:01:05.043')
  #DEBUG_PA: pa_words[7]=(date_modified='2011-01-14 00:46:40.843')
  #DEBUG_PA: pa_words[8]=(delete_level='0')
  #DEBUG_PA: pa_words[9]=(description='No description available.')
  #DEBUG_PA: pa_words[10]=(enabled='0')
  #DEBUG_PA: pa_words[11]=(has_schedule='1')
  #DEBUG_PA: pa_words[12]=(has_step='2')
  #DEBUG_PA: pa_words[13]=(has_target='1')
  #DEBUG_PA: pa_words[14]=(job_id='9A07A109-1140-47C3-BFBD-DB66E0E50BE8')
  #DEBUG_PA: pa_words[15]=(last_run_date='20110112')
  #DEBUG_PA: pa_words[16]=(last_run_outcome='0')
  #DEBUG_PA: pa_words[17]=(last_run_time='32059')
  #DEBUG_PA: pa_words[18]=(name='collection_set_2_collection')
  #DEBUG_PA: pa_words[19]=(next_run_date='0')
  #DEBUG_PA: pa_words[20]=(next_run_schedule_id='0')
  #DEBUG_PA: pa_words[21]=(next_run_time='0')
  #DEBUG_PA: pa_words[22]=(notify_email_operator='(unknown)')
  #DEBUG_PA: pa_words[23]=(notify_level_email='0')
  #DEBUG_PA: pa_words[24]=(notify_level_eventlog='2')
  #DEBUG_PA: pa_words[25]=(notify_level_netsend='0')
  #DEBUG_PA: pa_words[26]=(notify_level_page='0')
  #DEBUG_PA: pa_words[27]=(notify_netsend_operator='(unknown)')
  #DEBUG_PA: pa_words[28]=(notify_page_operator='(unknown)')
  #DEBUG_PA: pa_words[29]=(originating_server='BILLB\\MSSQL1')
  #DEBUG_PA: pa_words[30]=(owner='sa')
  #DEBUG_PA: pa_words[31]=(start_step_id='1')
  #DEBUG_PA: pa_words[32]=(type='1')
  #DEBUG_PA: pa_words[33]=(version_number='5')

  foreach $this_line (split('\n',$sqljob_data[$thishost]))
  {
    &packetParse($this_line) if $this_line =~ /^DDP:/;

    $pa_counter = -1;
    foreach $this_field (@pa_words)
    {
      $pa_counter++;
      print "DEBUG_PA: pa_words[$pa_counter]=($this_field)\n" if $debug_jobs;
      $this_verb = (split(/\=/,$this_field)) [0];
      $this_noun = (split(/\=/,$this_field)) [1];

      #---- Remove leading and trailing quotes from data field (after = sign)
      $this_noun =~ s/^'//;
      $this_noun =~ s/'$//;

      $this_job_data{$this_verb} = $this_noun;
    }

    #---- Process THIS JOB
    print "DEBUG_JOB: name=$this_job_data{'name'}\n" if $debug_jobs ;
    
    #---- Data massage, counters zero
    $job_events       = ""; 
    $job_event_cnt    = 0; 
    $this_notes       = ""; 

    #---- Last run timestamp
    $o_lastrun_hours_since = "?"; #---- Default value 
    if ($this_job_data{'last_run_date'} == 0 || $this_job_data{'last_run_date'} eq "") 
    {
      $o_lastrun = "?"; 
    }
    else
    {
      $o_lastrun_time   = $this_job_data{'last_run_time'}; 
      $o_lastrun_time_p = sprintf("%06d", $o_lastrun_time);
      $o_lastrun        = substr($this_job_data{'last_run_date'},0,4) . "/" .  
			  substr($this_job_data{'last_run_date'},4,2) . "/" .  
			  substr($this_job_data{'last_run_date'},6,2) . "-" .  
			  substr($o_lastrun_time_p,0,2) . ":" .  
			  substr($o_lastrun_time_p,2,2) . ":" .  
			  substr($o_lastrun_time_p,4,2); 
      $o_lastrun_ts_num = &timeToNum($o_lastrun); 
      $zsecdiff = time - $o_lastrun_ts_num; 
      $o_lastrun_hours_since = sprintf "%.2f",($zsecdiff / 3600);
      ##print "DEBUG - o_lastrun=$o_lastrun o_lastrun_time=$o_lastrun_time o_lastrun_time_p=$o_lastrun_time_p\n"; 
    }

    #---- Last run outcome
    $o_lastoutcome = $this_job_data{'last_run_outcome'} ; 
    if    ($o_lastoutcome == 0) { $o_lastoutcome = "0: Failed";  }
    elsif ($o_lastoutcome == 1) { $o_lastoutcome = "1: Success";  }
    elsif ($o_lastoutcome == 3) { $o_lastoutcome = "3: Cancelled"; }
    elsif ($o_lastoutcome == 5) { $o_lastoutcome = "5: Never Ran?"; }
    else                        { $o_lastoutcome = "$o_lastoutcome: ???";  }
    if    ($o_lastoutcome =~ /Success/) { $c_outcome = "lime"; }
    else                                { $c_outcome = "pink"; }
    #---- OLD
    #---- if    ($o_lastoutcome =~ /Failed/ && $this_job_data{'enabled'} == 1) 
    #---- New

    if ($o_lastoutcome =~ /Failed/ && $this_job_data{'enabled'} == 1 && $this_job_data{'current_execution_status'} != 1) 
    {
      #---- This job has failed - We need to decide if this was EXCLUDED or NOT
      $count_this_failure = 1; 
     
      #---- We will create a JOB FAILURE event, unless these exclusions have occurred
      ## elsif ($F1 eq "MSSQL_Job_Check_Cat_Excl_String:")   { $mssql_job_check_cat_excl_string[$i_hosts]  = $F2; }
      ## elsif ($F1 eq "MSSQL_Job_Check_Name_Excl_String:")  { $mssql_job_check_name_excl_string[$i_hosts] = $F2; }

      #---- Old
      #if    ( $mssql_job_check_cat_excl_string[$thishost]  && index(uc $this_job_data{'category'}, uc $mssql_job_check_cat_excl_string[$thishost]) > -1)
      #{
      #  $this_notes .= "Job Failure OK - JOB_CAT "; 
      #}

      #---- New
      if ($mssql_job_check_cat_excl_string[$thishost])
      {
	foreach $this_excl_string ( split(/\,/,  $mssql_job_check_cat_excl_string[$thishost] ))
	{
	  &msg("DEBUG - Checking this job category ($this_job_data{'category'}) against search string ($this_excl_string)") if $debug_jobs2; 
	  if (index(uc $this_job_data{'category'}, uc $this_excl_string) > -1) 
          { 
            $this_notes .= "Job Failure OK - JOB_CAT - Exclude by ($this_excl_string)"; 
            $count_this_failure = 0; 
          }
	}
      }

      #---- Old
      #elsif ( $mssql_job_check_name_excl_string[$thishost] && index(uc $this_job_data{'name'},     uc $mssql_job_check_name_excl_string[$thishost]) > -1)
      #{
      #  $this_notes .= "Job Failure OK - JOB_NAME "; 
      #}

      #---- New
      if ($mssql_job_check_name_excl_string[$thishost])
      {
	foreach $this_excl_string ( split(/\,/,  $mssql_job_check_name_excl_string[$thishost] ))
	{
	  &msg("DEBUG - Checking this job name ($this_job_data{'name'}) against search string ($this_excl_string)") if $debug_jobs2; 
	  if (index(uc $this_job_data{'name'}, uc $this_excl_string) > -1) 
          { 
            $this_notes .= "Job Failure OK - JOB_NAME - Exclude by ($this_excl_string)"; 
            $count_this_failure = 0; 
          }
	}
      }

      if ($count_this_failure == 1)   #---- If neither of those are true, then go ahead with the event
      {
	$job_failed_counter++; 
	$job_failed_details .= 
	  "$job_failed_counter. JobName: [$this_job_data{'name'}] - LastRunOutcome: [$o_lastoutcome] - LastRunTimestamp: $o_lastrun ($o_lastrun_hours_since Hours Ago)\n"; 
	$job_event_cnt++; 
	$job_events .= "Job FAILED "; 
      }
    }

    #---- Job enabled 
    $o_enabled = $this_job_data{'enabled'}; 
    if    ($o_enabled == 1) { $o_enabled = "1: Yes"; }
    elsif ($o_enabled == 0) { $o_enabled = "0: No"; }
    else                    { $o_enabled = "$o_enabled: ???";  }
    if ($o_enabled =~ /Yes/) { $c_enabled = "lime"; }
    else                     { $c_enabled = "pink"; }

    #---- Job status 
    $o_status = $this_job_data{'current_execution_status'}; 
    if    ($o_status == 1) { $o_status = "1: Executing"; }
    elsif ($o_status == 2) { $o_status = "2: WaitingForThread"; }
    elsif ($o_status == 3) { $o_status = "3: BetweenRetries"; }
    elsif ($o_status == 4) { $o_status = "4: Idle"; }
    elsif ($o_status == 5) { $o_status = "5: Suspended"; }
    elsif ($o_status == 6) { $o_status = "6: (Obsolete)"; }
    elsif ($o_status == 7) { $o_status = "7: PerformingCompletion"; }
    else                   { $o_status = "$o_status: ???";  }
    if ($o_status =~ /Executing/) { $c_status = "lime"; }
    else                          { $c_status = "white"; }

    #---- Job owner
    $this_job_owner = uc $this_job_data{'owner'}; 
    $this_job_owner =~ s/\\\\/\\/;
    if ($this_job_owner eq $job_good_owner) 
    {
      $c_owner = "lime"; 
    }
    elsif (index(uc $mssql_job_ok_owners[$thishost],uc $this_job_owner) > -1)
    {
      $c_owner = "lime"; 
    }
    else
    {
      $c_owner = "pink"; 
      $job_owner_counter++; 
      $job_owner_fix      .= "-- $job_owner_counter. Change - JOB [$this_job_data{'name'}] Owner from $this_job_owner to $job_good_owner
USE [msdb]
GO
EXEC msdb.dbo.sp_update_job \@job_name=N'$this_job_data{'name'}', \@owner_login_name=N'$job_good_owner'
GO\n"; 
      $job_owner_rollback .= "-- $job_owner_counter. Rollback - JOB [$this_job_data{'name'}] Owner from $job_good_owner to $this_job_owner
-- USE [msdb]
-- GO
-- EXEC msdb.dbo.sp_update_job \@job_name=N'$this_job_data{'name'}', \@owner_login_name=N'$this_job_owner'
-- GO\n"; 
    }

    #---- DBC Settings
    $this_job_category = uc $this_job_data{'category'}; 
    $this_job_name     = uc $this_job_data{'name'}; 
    $dbc_job_settings  = ""; 

    if ($mssql_job_cat_mbr[$thishost]{$this_job_category} == 1) 
    { 
      $dbc_job_settings .= "DBC: This Job Category MUST BE RUNNING"; 
      #---- Old
      ## if ($o_status !~ /executing/i && $o_enabled =~ /Yes/)
      #---- New
      if ($o_status !~ /executing/i && $o_status !~ /betweenretries/i && $o_enabled =~ /Yes/)
      {
        $ev_cat = "Avail";
        &event("C",$thishost,"JobName=($this_job_name) Category=($this_job_category) Should be EXECUTING or BETWEENRETRIES (Category) - JobStatus=($o_status)","Job-Not-Running-Category","DBA351");
        $job_event_cnt++; 
        $job_events .= "Job SHOULD BE Running (Category) "; 
      }
    } 

    if ($mssql_job_name_mbr[$thishost]{$this_job_name} == 1) 
    { 
      $dbc_job_settings .= "DBC: This Job Name MUST BE RUNNING"; 
      #---- Old 
      ## if ($o_status !~ /executing/i && $o_enabled =~ /Yes/)
      #---- New 
      if ($o_status !~ /executing/i && $o_status !~ /betweenretries/i && $o_enabled =~ /Yes/)
      {
        $ev_cat = "Avail";
        &event("C",$thishost,"JobName=($this_job_name) Category=($this_job_category) Should be EXECUTING or BETWEENRETRIES (JobName) - JobStatus=($o_status)","Job-Not-Running-Name","DBA351");
        $job_event_cnt++; 
        $job_events .= "Job SHOULD BE Running (JobName) "; 
      }
    } 
    #---- Process any events
    if ($job_event_cnt == 0) { $c_job_events = "lime"; $job_events = "OK"; }
    else                     { $c_job_events = "pink";  }

    $job_tr_row{$this_job_data{'name'}} = "<tr bgcolor=$table_rowcolor>
      <td nowrap bgcolor=$c_status>$f_s <b> $this_job_data{'name'}  </b> 
      <td >  <b> $f_s $dbc_job_settings </b>
      <td bgcolor=$c_job_events >  <b> $f_s $job_events </b>
      <td bgcolor=$c_status>  <b> $f_s $o_status </b>
      <td bgcolor=$c_enabled>  <b> $f_s $o_enabled </b>
      <td nowrap >$f_s  <b>  $this_job_data{'category'} </b>
      <td nowrap >$f_s  <b>  $this_job_data{'date_modified'} </b>
      <td nowrap>  <b> $f_s $o_lastrun </b>
      <td bgcolor=$c_outcome>  <b> $f_s $o_lastoutcome </b>
      <td align=right> <b> $f_s $o_lastrun_hours_since </b>
      <td bgcolor=$c_owner> <b> $f_s $this_job_owner </b>
      <td nowrap>  <b> $f_s $this_notes </b>
    "; 

  }

  &logDetails($thishost,"</table>");
  &logDetails($thishost,"<br><a name='sqlJobs'> <h3>MSSQL Jobs</h3>");
  ##&logDetails($thishost,"$f_s ( )");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Job Name<br>(Color from Current Execution Status)
    <th>$f_s DBC Settings<br>For This Job <br>(If Any) 
    <th>$f_s Events For<br>This Job<br>(If Any) 
    <th>$f_s Current<br> Execution<br> Status 
    <th>$f_s Job<br>Enabled?
    <th>$f_s Job<br> Category
    <th>$f_s Last<br> Modified<br> Date
    <th>$f_s Last<br> Ran<br>Timestamp
    <th>$f_s Last<br> Ran<br>Success?
    <th>$f_s Hours<br> Since<br>Last Run
    <th>$f_s Job<br> Owner
    <th>$f_s Monitoring<br> Notes
  ");

  foreach (sort keys %job_tr_row)
  {
    &logDetails($thishost,$job_tr_row{$_}); 
  }

  &logDetails($thishost,
    "</table>");

  &logDetails($thishost,
    "<br><font size=2>- You have specified in the <a href='http://dbamon.com/config/dbc_mssql.shtml'><b>DBC File</b></a> MSSQL_Job_Fail_Check: <b>$mssql_job_fail_check[$thishost]</b>");
  &logDetails($thishost,
    "<br><font size=2>- You have specified in the <a href='http://dbamon.com/config/dbc_mssql.shtml'><b>DBC File</b></a> MSSQL_Job_Check_Name_Excl_String: <b>$mssql_job_check_name_excl_string[$thishost]</b>");
  &logDetails($thishost,
    "<br><font size=2>- You have specified in the <a href='http://dbamon.com/config/dbc_mssql.shtml'><b>DBC File</b></a> MSSQL_Job_Check_Cat_Excl_String: <b>$mssql_job_check_cat_excl_string[$thishost]</b>");
  &logDetails($thishost,
    "<br><font size=2>- You have specified in the <a href='http://dbamon.com/config/dbc_mssql.shtml'><b>DBC File</b></a> that jobs in following JOB CATEGORIES MUST BE EXECUTING:");

  $wout = ""; 
  foreach $this_job_cat (sort keys %{ $mssql_job_cat_mbr[$thishost] })
  {
    $wout .= "$this_job_cat ";  
  }
  $wout = "(None)" if ! $wout;
  &logDetails($thishost,"<b>$wout</b>");

  &logDetails($thishost,
    "<br><font size=2>- You have specified in the <a href='http://dbamon.com/config/dbc_mssql.shtml'><b>DBC File</b></a> that jobs in following JOB NAMES MUST BE EXECUTING:");
  $wout = ""; 
  foreach $this_job_name (sort keys %{ $mssql_job_name_mbr[$thishost] })
  {
    $wout .= "$this_job_name ";  
  }
  $wout = "(None)" if ! $wout;
  &logDetails($thishost,"<b>$wout</b>");

  &logDetails($thishost,"<hr>");

  #---- Events?
  if ($job_owner_counter > 0 && $g_sql_job_owner_event eq "Y")
  {
    #chop($date = `date +%Y/%m/%d-%H:%M:%S`);
    $date = &getdate; 
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "
-- ================================================================= 
--   SQL To Correct JOB Names (Generated: $date): 
-- ================================================================= 
";
    print TMPFL2 " \n";
    print TMPFL2 "-- Section A: SQL To CHANGE: \n";
    print TMPFL2 " \n";
    print TMPFL2 "$job_owner_fix";
    print TMPFL2 " \n";
    print TMPFL2 "-- Section B: SQL To ROLLBACK (Commented): \n";
    print TMPFL2 " \n";
    print TMPFL2 "$job_owner_rollback";
    close(TMPFL2);

    $ev_cat = "Mgmt";
    &event("U",$thishost,"Job Owner - Found $job_owner_counter Job(s) with Incorrect JOB OWNER (Owner should be $job_good_owner)","Job-Owner=$job_owner_counter","DBA352",$tmpfl2);
  }

  &msg("DEBUG - job_failed_counter=$job_failed_counter mssql_job_fail_check[$thishost]=$mssql_job_fail_check[$thishost]") if $debug_jobs2; 
  if ($job_failed_counter > 0 && $mssql_job_fail_check[$thishost] eq "Y")
  {
    #chop($date = `date +%Y/%m/%d-%H:%M:%S`);
    $date = &getdate; 
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "Jobs with a LastRunOutcome of Failed:\n\n";
    print TMPFL2 "$job_failed_details";
    close(TMPFL2);

    #---- Old
    ## &event("C",$thishost,"Job Status - Found $job_failed_counter Job(s) with LastRunOutcome=Failed (Enabled Jobs only)","Job-Failed=$job_failed_counter","DBA354",$tmpfl2);
    #---- New
    $ev_cat = "Avail";
    &event("C",$thishost,"Job Status - Found Job(s) with LastRunOutcome=Failed (Enabled Jobs only)","Job-Failed=$job_failed_counter","DBA354",$tmpfl2);
  }
}
# -----------------------------------------------------------------------------
1;
